#!/usr/bin/perl -w

use strict;
use File::Copy;

my $orig_tree = shift || '';
my $dest_tree = shift || '';

die "No trees given" unless ($orig_tree && $dest_tree);

# Remove ending slashes from tree pathes
$orig_tree =~ s#/$##;
$dest_tree =~ s#/$##;

my $copied = find_files($orig_tree);

sub find_files {
	my $dir = shift;

	opendir(DIR,"$dir");
	my @files = readdir(DIR);
	closedir(DIR);

	my $counter = 0;
	foreach my $file (@files) {
		# Skip . and ..
		next if ($file =~ m/^.{1,2}$/);
		my $fullpath = "$dir/$file";
		if (-f $fullpath) {
			if ($file =~ m/(\.|\=)id$/) {
				my $basepath = $fullpath;
				$basepath =~ s/^${orig_tree}//;
				copy($fullpath,"$dest_tree/$basepath") or warn "Couldn't copy $basepath\n";
				$counter++;
			}
		}
		elsif (-d $fullpath) {
			$counter += find_files($fullpath);
		}
	}
	return $counter;
}

print "Copied $copied files\n";
